#ifndef _COMM_H
#define _COMM_H

// ------- internal structures ---------------------------

// communication fd
#define FD 7	

enum TPacketType {packetEmpty=0, packetBorn=1, packetDoStep=2, packetDoneStep=3, packetQuit=4, packetName=5};

typedef struct {
  int size;
  TPacketType packetType;
  unsigned char *data;
} TPacket;

TPacket Packet(void);				// return empty packet (but with *data set correctly to internal buffer)

TPacket RecvPacket(int fd, TPacketType pt);		// receive a packet of selected type (ignore any other packets)
int SendPacket(int fd, TPacket packet);			// send a packet

// extracting data from packet
int GetInt(TPacket pac, int offset);		// get int (4bytes) from specified offset
int GetByte(TPacket pac, int offset);		// get byte (1byte) from specified offset

void SetInt(TPacket pac, int offset, int val);			// set int (4bytes) from specified offset
void SetByte(TPacket pac, int offset, unsigned char val);	// set byte (1byte) from specified offset

#endif   /* _COMM_H */
