#include <stdio.h>
#include <string.h>
#include <stdlib.h>

#include "conffiles.h"

#define MAX_LEN 1024

static char *fname = NULL;
static char data[MAX_LEN];

int ConfOpen(char *name) {
  fname = (char *) malloc(strlen(name)+1);
  strcpy(fname,name);
  return 1;
}

void trim(char *s) {
  char ss[MAX_LEN], *q=s;
  int len=0;
  
  while ((*q)==' ') q++;
  while ( (q[0]!=0) && (q[0]!='=') && (q[0]!='\n') ) {
    ss[len]=q[0];
    q++;
    len++;
  }
  ss[len]=0;
  
  while ((len>0) && (ss[len-1]==' ')) { ss[len-1]=0; len--; }
  
  strcpy(s,ss);
}

char *ConfGetStr(char *name) {
  char *res=NULL;
  FILE *f = fopen(fname,"r");
  if (f==NULL) return NULL;
  
  while (!feof(f)) {
    char s1[MAX_LEN], s2[MAX_LEN];
    
    fscanf(f,"%[^=]=%[^\n] ",s1,s2);
    trim(s1);
    trim(s2);
    
    if (!strcasecmp(name, s1)) {
      strcpy(data,s2);
      fprintf(stderr,"CONF: %s=%s\n",name,s2);
      res=data;
    }
  }
  
  fclose(f);
  return res;
}

int ConfGetInt(char *name) {
  int res=-1;
  if (ConfGetStr(name)!=NULL) {
    sscanf(data,"%d",&res);
  }
  return res;
}

