#include "gui.h"
#include "config.h"

// #include "proboj.h"
#include "sprites/nina.h"
// #include "formula1_out.h"
// #include "back1.h"
#include "sprites/objs.h"

#define AWAY_X 15000
#define AWAY_Y 15000

#define FULLSCREEN 0

static int TEXT_cache[MAX_PLAYERS][10];

int default_player_color[MAX_PLAYERS][3] = { {255,0,0}, {0,255,0}, {120,120,255}, {255,200,50}, {120,255,220} };
int player_color[MAX_PLAYERS][3] = { {255,0,0}, {0,255,0}, {120,120,255}, {255,200,50}, {120,255,220} };

int fastmode=0;
int pausemode=0;
/* static int fps_counter=0, fps_time=0; */

double PLAYER_SCALE = 1.0;

static KrEngine **engine;
static KrSprite **obj_sprite;
static KrTextBox **text;
static KrResourceVault **vaults;
static KrSprite *background = NULL;
static TGlobalMap *map;


static int obj_count = 0;			// number of sprites in obj_sprite
static int obj_free_count = 0;			// number of free slots in obj_sprite (#elem. of obj_free)
static int obj_free[MAX_SPRITES];		// free indexes in obj_sprite


bool init_SDL(SDL_Surface** screen, KrEngine** engine)
{
	KrRect wins[20];
	KrRGBA color;
	if(SDL_Init(SDL_INIT_VIDEO|SDL_INIT_TIMER|SDL_INIT_NOPARACHUTE) == -1) {
		printf("Could not initialize SDL: %s.\n",SDL_GetError());
		return 0;
	}
	*screen = SDL_SetVideoMode(SCREEN_W,SCREEN_H,32,SDL_HWSURFACE|SDL_ANYFORMAT|SDL_HWACCEL);

	SDL_WM_ToggleFullScreen(*screen);
	
	wins[0].Set(0,0,SCREEN_W,SCREEN_H);
/*
	wins[1].Set(SCREEN_W/3/2+1,0,2*SCREEN_W/3/2-1,SCREEN_W/3/2-1);
	wins[2].Set(0,SCREEN_W/3/2+1,SCREEN_W/3/2-1,2*SCREEN_W/3/2-1);
	wins[3].Set(SCREEN_W/3/2+1,SCREEN_W/3/2+1,2*SCREEN_W/3/2-1,2*SCREEN_W/3/2-1);

	wins[4].Set(0,2*SCREEN_W/3+1,SCREEN_W,SCREEN_H);	// spodne okienko
	wins[5].Set(SCREEN_W/3+1,0,SCREEN_W,2*SCREEN_W/3-1);	// mala mapa
	wins[6].Set(0,SCREEN_W/3+1,SCREEN_W/3-1,2*SCREEN_W/3-1);	// texty
*/
	
	color.Set(0,0,200,255);

	*engine = new KrEngine(*screen, 1, wins, &color);
//	*engine = new KrEngine(*screen, 7, wins, NULL);

//	(*engine)->Tree()->Root()->SetPos(-1000,-1000,4);
//	(*engine)->Tree()->Root()->SetPos(10000,10000,6);

//	if (PLAYER_SCALE!=1) for (int i=0;i<MAX_PLAYERS;i++) (*engine)->Tree()->Root()->SetScale(PLAYER_SCALE,PLAYER_SCALE,i);

	bzero(TEXT_cache, sizeof(TEXT_cache));
	
	return 1;
}

bool gui_getkey(SDL_Surface **screen, int &dx, int &dy, bool &tab)
{
        int stoppednow=pausemode;
	SDL_Event event;
	SDL_EnableUNICODE( 1 );

	while (SDL_PollEvent(&event)||stoppednow)
	{
	    switch( event.type ) {
		case SDL_KEYDOWN:
			if(event.key.keysym.sym == SDLK_UP) { dy--; }
			if(event.key.keysym.sym == SDLK_DOWN) { dy++; }
			if(event.key.keysym.sym == SDLK_RIGHT) { dx++; }
			if(event.key.keysym.sym == SDLK_LEFT) { dx--; }

			if ((event.key.keysym.sym == SDLK_q) &&
			    (event.key.keysym.mod & KMOD_SHIFT))  { fastmode=RET_HALT; }


			if(event.key.keysym.sym == SDLK_q) {
			    // fprintf(stderr,"FPS: %02f\n",fps_counter*1000.0/(SDL_GetTicks()-fps_time));
			    return 0; 
			}
			if(event.key.keysym.sym == SDLK_ESCAPE) { tab = true; }
			if(event.key.keysym.sym == SDLK_f) { SDL_WM_ToggleFullScreen(*screen); }
			if(event.key.keysym.sym == SDLK_s) { fastmode=!fastmode; }
			
			if(event.key.keysym.sym == SDLK_0) { fastmode=0; }
			if(event.key.keysym.sym == SDLK_1) { fastmode=1; }
			if(event.key.keysym.sym == SDLK_2) { fastmode=2; }
			if(event.key.keysym.sym == SDLK_3) { fastmode=3; }
			if(event.key.keysym.sym == SDLK_4) { fastmode=4; }
			
			if(event.key.keysym.sym == SDLK_p) { pausemode=!pausemode; stoppednow=0; }
			if(event.key.keysym.sym == SDLK_n) { stoppednow=0; }

			
		break;
		case SDL_QUIT:
			return 0;
		break;

		default:
			break;
	    }
	}
	return 1;
}


/*
void text_out(player* players, KrTextBox **text, int map_laps)
{
	char tmp[500];
	
	for(int i = 0; i < PLAYER_CNT; i++) 
	{
	    if ((TEXT_cache[i][0]!=players[i].laps) || (TEXT_cache[i][1]!=players[i].latency))
	    {
		snprintf(tmp, 50, " %s\n", players[i].name);
		text[i]->SetTextChar(tmp,0);
		snprintf(tmp, 50, " points: %d    laps: %g\n", players[i].points, players[i].laps*0.25);
		text[i]->SetTextChar(tmp,1);
		
		TEXT_cache[i][0]=players[i].laps;
		TEXT_cache[i][1]=players[i].latency;
	    }
	}
	
	// spodny ramcek
	int t=(SDL_GetTicks()-fps_time)/1000;
	sprintf(tmp, " %d:%02d     Laps to go: %d", (t/60)%60,t%60, map_laps);
	text[PLAYER_CNT]->SetTextChar(tmp,0);
}
*/


bool LoadVault(KrResourceVault *vault, char *name)
{
    fprintf(stderr,"Loading %s...",name);
    if (!vault->LoadDatFile(name)) 
    { 
        fprintf(stderr, " Error loading dat file: %s\n", name); 
        return false;	
    }
    fprintf(stderr," done\n");
    return true;
}


bool get_sprites(KrEngine **_engine, KrSprite **_obj_sprite, KrTextBox **_text, KrResourceVault **_vaults, char *mapname, TGlobalMap *_map)
{
	char buff[1024];
	sprintf(buff,"%s.dat",mapname);
	engine=_engine;
	obj_sprite=_obj_sprite;
	text=_text;
	vaults=_vaults;
	map=_map;
	static int first_pass=1;

	
	// font -> engine->Vault()
	if (first_pass) {
	  if (!LoadVault((*engine)->Vault(), "sprites/nina.dat")) return 0;
	}
	 

	// objects -> vaults[0]
	if (!LoadVault(vaults[0],"sprites/objs.dat")) return 0;

	// score background -> vaults[1]

	bool has_back = true;
	if (!LoadVault(vaults[1],buff)) has_back=false;


	if (has_back) {
  	  KrSpriteResource* backgroundRES = vaults[1]->GetSpriteResource(2 << 0);
 	  GLASSERT(backgroundRES);

	  background = new KrSprite(backgroundRES);
	  
	  background->SetPos(10,10);
	  background->SetScale(PLAYER_SCALE,PLAYER_SCALE,KR_ALL_WINDOWS);
	  background->SetZDepth(1);
	  (*engine)->Tree()->AddNode(0, background);
	}  

 	
	// background color	
	KrColorTransform color;
	KrRGBA col;
	col.Set(0,0,30);
	(*engine)->FillBackgroundWindow(0,&col);

/*	for(int i = 0; i < MAX_OBJECTS; i++) {
		obj_sprite[i] = new KrSprite(objRES);
		obj_sprite[i]->SetZDepth(3);
		obj_sprite[i]->SetScale(1,1,KR_ALL_WINDOWS);
		obj_sprite[i]->SetPos(AWAY_X,AWAY_Y);
		(*engine)->Tree()->AddNode(0,obj_sprite[i]);
		printf("\r%d/%d...",i,MAX_OBJECTS);
	}
*/

	// TODO: fonty
	if (first_pass) {
	  KrFontResource* ninaRes = (*engine)->Vault()->GetFontResource( FONT_NINA );
	  ninaRes->CacheScale(FONT_SCALE, FONT_SCALE);
	}
	
	(*engine)->Draw();
	
	first_pass=0;
	return true;
}

int create_sprite(int x, int y, int frame, int zdepth) {
  int index=-1;
  
  if (obj_free_count>0) {
    index=obj_free[--obj_free_count];
  } else {
    if (obj_count < MAX_SPRITES) index=obj_count;
  }
  
  if (index<0) return -1;
  
  obj_count++;
  
  KrSpriteResource* objRES = vaults[0]->GetSpriteResource(OBJS_OBJECTS);
  GLASSERT(objRES);

  if (PLAYER_SCALE!=1) objRES->CacheScale(PLAYER_SCALE,PLAYER_SCALE);

  obj_sprite[index] = new KrSprite(objRES);
  obj_sprite[index]->SetZDepth(zdepth);
  obj_sprite[index]->SetPos(10+(int)(10*PLAYER_SCALE*x), 10+(int)(10*PLAYER_SCALE*(map->h-1-y)));
  obj_sprite[index]->SetScale(PLAYER_SCALE,PLAYER_SCALE,KR_ALL_WINDOWS);
  obj_sprite[index]->SetFrame(frame);
  (*engine)->Tree()->AddNode(0,obj_sprite[index]);
    
  return index;
}

void delete_sprite(int index) {
  if ((index>=0) && (obj_sprite[index]!=NULL)) {
    (*engine)->Tree()->DeleteNode(obj_sprite[index]);
    obj_sprite[index]=NULL;
    
    obj_free[obj_free_count++]=index;
    obj_count--;
  }
}

void delete_all_sprites(void) {
  (*engine)->Tree()->DeleteNode(background);
  for (int i=0;i<NR_VAULTS;i++) delete vaults[i];
  
  obj_count = 0;
  obj_free_count = 0;
}
