#include <stdio.h>
#include <stdlib.h>
#include <time.h>

#include <queue>
#include <fstream>

using namespace std;

#include "config.h"

// my own data
TEntity base;

int prizeWorker=0;
int prizeFighter=0;

extern char *PlayerName;

// Added by team3:

#define START_FIGHTER 12
#define MIN_FIGHTERS 10
#define MAX_FIGHTERS 300

#define MIN_WORKERS 15


#define UNSTUCK 2 
#define CREATE_FIGHTER 20

char mymap[GLOBAL_MAP_SIZE][GLOBAL_MAP_SIZE];
int map_width,map_height;

ofstream flog("log3.txt");

struct Coord {
	Coord(int mx=-1,int my=-1):x(mx),y(my) {};
	bool operator==(const Coord &left) {return x==left.x && y==left.y;}
	bool operator!=(const Coord &left) {return !(x==left.x && y==left.y);}
	int x,y;
};

Coord find_neareset(char what,Coord origin) {
	queue<Coord> q;
	int x,y;
	Coord me;
	unsigned char checked[GLOBAL_MAP_SIZE][GLOBAL_MAP_SIZE];
	
	memset(checked,0,sizeof(checked));
	q.push(origin);
	checked[origin.y][origin.x]=true;
	
	while (!q.empty()) {
		me=q.front();
		q.pop();
		for (x=-1;x<1;x++)
			for (y=-1;y<1;y++) {	
				if ((me.x+x<0) || (me.y+y<0) ||
						(me.x+x>=map_width) ||
						(me.y+y>=map_height)) 
					continue;
				if (mymap[me.y+y][me.x+x]==what) return Coord(me.x+x,me.y+y);
				if (checked[me.y+y][me.x+x]) continue;
				if (mymap[me.y+y][me.x+x]=='#') continue;
				q.push(Coord(me.x+x,me.y+y));
				checked[me.y+y][me.x+x]=true;
			};
	};
	return Coord(-1,-1);
};

int get_distance(Coord what, Coord origin) {
	queue<Coord> q;
	int x,y;
	Coord me;
	Coord brk(-1,-1);
	int dist=0;
	unsigned char checked[100][100];
	
	memset(checked,0,sizeof(checked));
	q.push(origin);
	q.push(brk);
	
	while (!q.empty()) {
		me=q.front();
		q.pop();
		
		if (me==brk) {
			q.push(brk);
			dist++;
			continue;
		};
		
		for (x=-1;x<1;x++)
			for (y=-1;y<1;y++) {
				if (me.y+y==what.y && me.x+x==what.x) return dist;
				if (checked[me.y+y][me.x+x]) continue;
				q.push(Coord(me.x+x,me.y+y));
				checked[me.y+y][me.x+x]=true;
			};
		
	};
	return -1;
};

TMoveAction get_direction(Coord origin, Coord target) {
	int dx,dy;

	dy=target.x-origin.x;
	dx=target.y-origin.y;
/*	flog<<"getdirect:"<<dx<<' '<<dy<<endl;
	flog<<"target:"<<target.x<<' '<<target.y<<endl;
	flog<<"origin:"<<origin.x<<' '<<origin.y<<endl;
*/
	if (dx<0 && ( abs(dx) >= abs(dy)) ) return dirLeft;
	if (dx>0 && ( abs(dx) >= abs(dy)) ) return dirRight;
	if (dy<0 && ( abs(dy) >= abs(dx)) ) return dirUp;
	if (dy>0 && ( abs(dy) >= abs(dx)) ) return dirDown;

//	flog << "In the place"<<endl;

	return dirStay;
};


//double fight_fast;//nejaky relativny koeficient - zavislost velkosti mapy od poctu fighterov ktori su potrebni
double danger; // nebeezpecie, ak uz su vsetci mrtvy nebude stale vyrabat vojakov, alebo naopak
// born
//   called when the entity borns
//    ent          -- this entity (id, coordinates, ...)
//    nplayers     -- number of players in a game
//    map_w,map_h  -- coordinates, size of the map
int born(TEntity ent, int nplayers, int map_w, int map_h, int pr_worker, int pr_fighter){
  srand(time(NULL)+(ent.x)*(ent.y+1*random()));
  sprintf(PlayerName,"ShroetKommando");
  base = ent;
  prizeWorker=pr_worker;
  prizeFighter=pr_fighter;
  danger=1;
  
  map_width=map_w;
  map_height=map_h;
  for(int i=0;i<map_height;i++)
	for(int j=0;j<map_width;j++)
		mymap[i][j]='_';
  return dirStay;
}

// step_(base|fighter|worker)
//   make a single step of a given entity
//    ent          -- this entity (id, coordinates, ...)
//    map          -- part of map visible around entity (with other entities)
//
//    *out_msg     -- message to send
//    returns direction to move in

int step_base(TEntity ent, TMap map, TEntityCount cnt, TMessage *out_msg)
{
  int pl=ID_PLAYER(ent.id);
  static int time=0, count=0, kill=0;
  if(count>cnt.workers+cnt.fighters)kill+=count-cnt.workers-cnt.fighters;
 /* if (random(10)<2) {
    if (ent.sugar >= prizeFighter) return bornFighter;
  } else {
    if (ent.sugar >= prizeWorker) return bornWorker;
  }*/

  // CO tak for cyklus co hlada v okoli nepriatela ? ak sa dostal az sem tak je zle
/*  time++;
  if(time>1000 && random()%10>7)return bornWorker;
  count=cnt.workers+cnt.fighters;
  if (kill>0)if(random()%5>2&&ent.sugar>=prizeFighter){ count++; kill--; return bornFighter;}
  if (cnt.workers<MIN_WORKERS&&ent.sugar>=prizeWorker){count++; return bornWorker;}
  if (random()%10>time/(map_width*3)&&ent.sugar>=prizeWorker){count++; return bornWorker;}
  	else if(ent.sugar>=prizeFighter){count++; return bornFighter;}
*/
  count=cnt.workers+cnt.fighters;
  if (random()%10<=4) return bornFighter ; else return bornWorker;
  return bornNone;
}

/*************************************************************************************************/



Coord Our_base(-1,-1);
const int bk=3;
Coord posl(-1,-1);//kde som bol minuly tah
int rmoves=UNSTUCK;

int step_fighter(TEntity ent, TMap map, TMessage *out_msg)
{
    // maximalny pocet tahov bez zmeny smeru
	static int dirStMax = 10;

	static int direction = random(6) + 1, oldX, oldY, dirStCnt = 0;

	// zistenie, ci sa podaril predosly tah a ci netreba zmenit smer
	int oldDir;
	if (((oldX == ent.x) && (oldY == ent.y)) || (dirStCnt > dirStMax)) {
	    oldDir = direction;
    	while (direction == oldDir) {
			direction = random(6) + 1;
		}
		dirStCnt = 0;
	}
	oldX = ent.x;
	oldY = ent.y;
	
	// hladanie najblizsieho enemyka
	int i, y, coordX = -1, coordY = -1, min = MAP_SIZE + 1, temp;
	for (i = 0; i < MAP_SIZE; i++) {
	    for (y = 0; y < MAP_SIZE; y++) {
			if (((ID_TYPE(map.field[i][y]) == 2) || (ID_TYPE(map.field[i][y]) == 3))
			 && (ID_PLAYER(map.field[i][y]) != ID_PLAYER(ent.id))) {
				temp = abs(MAP_SIZE/2+1 - i)*abs(MAP_SIZE/2+1 - i) + abs(MAP_SIZE/2+1 - y)*abs(MAP_SIZE/2+1 - y);
				if (temp < min) {
					min = temp;
					coordX = i;
					coordY = y;
				}
			}
		}
	}
    if (coordX > -1) {
	    if (coordX < MAP_SIZE/2) { return dirLeft; }
	    if (coordX > MAP_SIZE/2) { return dirRight; }
	    if (coordY < MAP_SIZE/2) { return dirUp; }
	    if (coordY < MAP_SIZE/2) { return dirDown; }
	}

	// ak nikde nie je
	dirStCnt += 1;
    return direction;
}

/***************************************************************************************************************/



int step_worker(TEntity ent, TMap map, TMessage *out_msg)
{	
	
	Coord tu_sme(map_height-(ent.y+bk),(ent.x+bk));
	bool fighterThere=false,sugarThere=false;
	int dx,dy,x,y;
	// Zalezitosti pre cukor
	Coord sugar; int sugar_move;
	// Zalezitosti pre preliezanie mapy
	static Coord roam_target(-1,-1);
	
//	flog<<"---"<<endl<<"Roam:"<<roam_target.x<<" "<<roam_target.y<<endl;

	//Ked som sa minuly tah nepohol, roamujem nahodne
	if (posl.x==tu_sme.x && posl.y==tu_sme.y) {
/*			flog<<"Pomoc, zasekol som sa "<<tu_sme.x<<" "<<tu_sme.y<<"; posl: "
										  <<posl.x  <<" "<<posl.y <<endl;
*/			//stuck, UNSTUCK_MOVES random
			rmoves=UNSTUCK;
			roam_target.x=-1;
	}
	posl=tu_sme;

	if (roam_target.x==-1 || rmoves) {
		if (rmoves) rmoves--;//zmensim random moves o 1
		roam_target.x=random()%map_width;
		roam_target.y=random()%map_height;
//		flog << "Novy ciel " <<roam_target.x <<" "<<roam_target.y<<endl;
	};
	//flog<<"Minimap: "<<endl;
	for (int x=MAP_SIZE-1;x>=0;x--){
		for (int y=0;y<MAP_SIZE; y++) {
			TID id=map.field[y][x];
			// Ulozime info do vlastnej minimapky
			if (ID_TYPE(id)==etWall) { 
				mymap[map_height-(ent.y+x)][ent.x+y]='#';
			}
			else if (ID_SUGAR(id)>0) {
				mymap[map_height-(ent.y+x)][ent.x+y]='S';  //  flog<<'S';
			}
			else if ((ID_TYPE(id)==etBase)&&
					(ID_PLAYER(ent.id)==ID_PLAYER(id))){
				mymap[map_height-(ent.y+x)][ent.x+y]='B';    //   flog<<'B';
				Our_base.x=map_height-(ent.y+x); Our_base.y=(ent.x+y);
			}//else flog<<'_';
			if (ID_TYPE(id)==etFighter && !ID_PLAYER(ent.id)) {
				fighterThere=true;
			};
		};
	}
/*	mymap[tu_sme.x][tu_sme.y]='O';
	flog<<"Mapa"<<endl;
	for(int i=0;i<map_height;i++)
	{	for(int j=0;j<map_width;j++) flog<<mymap[i][j];flog<<endl; }
*///	flog<<endl;
//	flog <<"Moje suradnice: "<< tu_sme.x << " " << tu_sme.y <<endl;
//	flog <<"Hladam cukor"<<endl;

	// Pohladam cukor, ak je niekde na blizku
	sugar=find_neareset('S',Coord(ent.x,ent.y));
//	flog<<"Nasiel som cukor"<<endl;
	if (sugar!=Coord(-1,-1)) sugarThere=true;

	// Pohyb k cukru
	if (false) {
		/*dx=ent.x-sugar.x;
		dy=ent.y-sugar.y;
		if (dy>0) sugar_move=dirUp;
		if (dy<0) sugar_move=dirDown;
		if (dx>0) sugar_move=dirRight;
		if (dx<0) sugar_move=dirLeft;*/
		sugar_move=get_direction(Coord(ent.x,ent.y),sugar);
	};

	// Ak nic nenajdeme, lozime po mape...
	if (ent.sugar>0 && !rmoves){ 
		/*
		 Treba upravit : ked idem z dola, mozem sa splhat na policka dole(3), ked
		 idem z rohu, mozem ist na krajnych 5(2 dole, 2 vpravo, jeden na rohu)
		  */
		if (tu_sme.x<Our_base.x) roam_target.x=Our_base.x-1; else
		if (tu_sme.x>Our_base.x) roam_target.x=Our_base.x+1; else 
							  roam_target.x=Our_base.x;	
 		if (tu_sme.y<Our_base.y) roam_target.y=Our_base.y-1; else
		if (tu_sme.y>Our_base.y) roam_target.y=Our_base.y+1; else 
							  roam_target.y=Our_base.y;
	}
	else if (!rmoves && !fighterThere/* && !sugarThere*/) {
		// Nikde nic, ideme hladat
		if(get_direction(tu_sme,roam_target)==dirStay) {
			roam_target.x=random()%map_width;
			roam_target.y=random()%map_height;
//			flog << "Novy ciel " <<roam_target.x <<" "<<roam_target.y<<endl;
		};
	}
	TMoveAction pohyb;
	
	bool SmerJeOK=1;
	
	pohyb=get_direction(tu_sme,roam_target);

	switch(pohyb) {
		dirUp:   if (ID_TYPE(mymap[tu_sme.x+1][tu_sme.y  ])!=etEmpty || (ID_SUGAR(mymap[tu_sme.x][tu_sme.y]) && ID_SUGAR(mymap[tu_sme.y+1][tu_sme.x  ]))) SmerJeOK=0; break;
		dirRight:if (ID_TYPE(mymap[tu_sme.x  ][tu_sme.y+1])!=etEmpty || (ID_SUGAR(mymap[tu_sme.x][tu_sme.y]) && ID_SUGAR(mymap[tu_sme.y  ][tu_sme.x+1]))) SmerJeOK=0; break;
		dirDown: if (ID_TYPE(mymap[tu_sme.x-1][tu_sme.y  ])!=etEmpty || (ID_SUGAR(mymap[tu_sme.x][tu_sme.y]) && ID_SUGAR(mymap[tu_sme.y-1][tu_sme.x  ]))) SmerJeOK=0; break;
		dirLeft: if (ID_TYPE(mymap[tu_sme.x  ][tu_sme.y-1])!=etEmpty || (ID_SUGAR(mymap[tu_sme.x][tu_sme.y]) && ID_SUGAR(mymap[tu_sme.y  ][tu_sme.x-1]))) SmerJeOK=0; break;
		default: break;
		}
	if (!SmerJeOK) {
			roam_target.x=random()%map_width;
	        roam_target.y=random()%map_height;
	        pohyb=get_direction(tu_sme,roam_target);
	}
	

	// 
/*  // test messages
  for (int j=0; j<MAP_SIZE; j++)
   for (int i=0; i<MAP_SIZE; i++) {
     if ( (ID_TYPE(map.field[i][j]) == etBase)  && 
          (ID_PLAYER(map.field[i][j]) == ID_PLAYER(ent.id)) ) {
//	printf("==================================\n");
//	printf("== SENDING MESSAGE TO BASE !!!  ==\n");
//	printf("== id=0x%08X",ent.id);
//	printf("==================================\n");

	if (ent.sugar) {
	  // chod smerom k zakladni odovzdat cukor
	  int dx=i-MAP_SIZE/2;
	  int dy=j-MAP_SIZE/2;
//	printf("==================================\n");
//	printf("== HEADING HOME !!!             ==\n");
//	printf("== id=0x%08X                ==\n",ent.id);
//	printf("==================================\n");
	  if ((dx<0) &&  (dy<0))  if (dx<dy) return dirDown; else return dirLeft;
	  if ((dx<0) &&  (dy>=0)) if (-dx<dy) return dirUp; else return dirLeft;
	  if ((dx>=0) && (dy<0))  if (dx<-dy) return dirDown; else return dirRight;
	  if ((dx>=0) && (dy>=0)) if (dx<dy) return dirUp; else return dirRight;
	} else {	
  	  if (random(100)==47) {		// sending message takes one move - don't do it too often ;)
	    out_msg->id  = map.field[i][j];
 	    out_msg->msg = 47;
	    return dirSend;
	  }
        }
     } 
   }
  
  return random(5);*/
}

